import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class AnimalBuilder extends JFrame
                           implements ItemListener
{
   private static final int
      NB_ANIMALS = 3,
      ANIMAL_PART_HEAD = 0,
      ANIMAL_PART_BODY = 1,
      ANIMAL_PART_FEET = 2,
      NB_ANIMAL_PARTS  = 3;

   private static final String []
   ANIMAL_SOURCE =
   {
      "Cat",
      "Dog",
      "Zebra"
   },
   ANIMAL_PARTS =
   {
      "Head",
      "Body",
      "Feet"
   };
   private JComboBox PickHead,
                     PickBody,
                     PickFeet;
   private JLabel TheHead,
                  TheBody,
                  TheFeet;
   private ImageIcon [][] icon;


   private void BuildAnimalParts ()
   {
      icon = new ImageIcon[NB_ANIMALS][NB_ANIMAL_PARTS];

      for (int i = 0; i < NB_ANIMALS; i++)
         for (int j = 0; j < NB_ANIMAL_PARTS; j++)
            icon[i][j] = new ImageIcon (ANIMAL_SOURCE[i] + "_" + ANIMAL_PARTS[j] + ".gif");
   }


   public AnimalBuilder ()
   {
      super ();
      init ();
   }

   public AnimalBuilder (String Title)
   {
      super (Title);
      init ();
   }

   public void init ()
   {
      // -- PickPanel goes NORTH
      final int PICKPANEL_NB_ROWS = 2,
                PICKPANEL_NB_COLS = 3;

      JPanel PickPanel = new JPanel ();

      PickHead = new JComboBox (ANIMAL_SOURCE);
      PickBody = new JComboBox (ANIMAL_SOURCE);
      PickFeet = new JComboBox (ANIMAL_SOURCE);

      PickHead.addItemListener (this);
      PickBody.addItemListener (this);
      PickFeet.addItemListener (this);

      PickPanel.setLayout (new GridLayout (PICKPANEL_NB_ROWS,
                                           PICKPANEL_NB_COLS));

      PickPanel.add (new JLabel ("Pick Head"));
      PickPanel.add (new JLabel ("Pick Body"));
      PickPanel.add (new JLabel ("Pick Feet"));

      PickPanel.add (PickHead);
      PickPanel.add (PickBody);
      PickPanel.add (PickFeet);

      getContentPane ().add (PickPanel, BorderLayout.NORTH);

      // -- ShowPanel goes CENTER
      final int SHOWPANEL_NB_ROWS = 3,
                SHOWPANEL_NB_COLS = 1;

      JPanel ShowPanel = new JPanel ();

      BuildAnimalParts ();

      ShowPanel.setLayout (new GridLayout (SHOWPANEL_NB_ROWS,
                                           SHOWPANEL_NB_COLS));

      TheHead = new JLabel (icon[0][ANIMAL_PART_HEAD]);
      TheBody = new JLabel (icon[0][ANIMAL_PART_BODY]);
      TheFeet = new JLabel (icon[0][ANIMAL_PART_FEET]);

      ShowPanel.add (TheHead);
      ShowPanel.add (TheBody);
      ShowPanel.add (TheFeet);

      getContentPane ().add (ShowPanel, BorderLayout.CENTER);

      addWindowListener (new WindowAdapter() { public void windowClosing (WindowEvent e) { System.exit (0); } } );

      UpdateDisplay ();
   }

   private void UpdateDisplay ()
   {
      // change all three pictures
      TheHead.setIcon (icon[PickHead.getSelectedIndex ()][ANIMAL_PART_HEAD]);
      TheBody.setIcon (icon[PickBody.getSelectedIndex ()][ANIMAL_PART_BODY]);
      TheFeet.setIcon (icon[PickFeet.getSelectedIndex ()][ANIMAL_PART_FEET]);
   }

   public void itemStateChanged (ItemEvent e)
   {
      UpdateDisplay ();
   }

   public static void main (String [] args)
   {
      AnimalBuilder frame = new AnimalBuilder ("The Animal Builder!");

      frame.pack ();
      frame.setVisible (true);
   }

} // class AnimalBuilder 
