import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class BoxLayoutDemo extends JFrame
{
   public BoxLayoutDemo (String Title)
   {
      super (Title);
      init ();
   }
   private Box CreateBox (int NbButtons,
                          String ButtonPrefix,
                          boolean Horizontal)
   {
      Box b;
      if (Horizontal)
         b = Box.createHorizontalBox ();
      else
         b = Box.createVerticalBox ();

      for (int i = 0; i < NbButtons; i++)
      {
         b.add (new JButton (ButtonPrefix + i));
      }
      return b;
   }

   private Box CreateLeftBox ()
   {
      final int NB_BUTTONS = 3;
      final String BUTTON_PREFIX = "Left button ";

      return CreateBox (NB_BUTTONS, BUTTON_PREFIX, false);
   }

   private Box CreateCenterBox ()
   {
      final int NB_BUTTONS = 2;
      final String BUTTON_PREFIX = "Center button ";

      return CreateBox (NB_BUTTONS, BUTTON_PREFIX, true);
   }

   private Box CreateRightBox ()
   {
      final int NB_BUTTONS = 3;
      final String BUTTON_PREFIX = "Right button ";

      return CreateBox (NB_BUTTONS, BUTTON_PREFIX, false);
   }

   public void init ()
   {
      final int NB_BOXES = 3;

      Box [] TheBoxes = new Box [NB_BOXES];

      TheBoxes [0] = CreateLeftBox   ();
      TheBoxes [1] = CreateCenterBox ();
      TheBoxes [2] = CreateRightBox  ();

      getContentPane ().add (TheBoxes [0], BorderLayout.WEST);
      getContentPane ().add (TheBoxes [1], BorderLayout.CENTER);
      getContentPane ().add (TheBoxes [2], BorderLayout.EAST);

      addWindowListener
      (
         new WindowAdapter()
         {
            public void windowClosing(WindowEvent e)
            {
               System.exit(0);
            }
         }
      );
   }

   public static void main (String [] args)
   {
      BoxLayoutDemo frame = new BoxLayoutDemo ("BoxLayout demo");
      frame.pack ();
      frame.setVisible (true);
   }
}
