import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class CardLayoutDemo extends JFrame implements ActionListener
{
   private CardLayout MyLayout;
   private JPanel CardPanel;

   public CardLayoutDemo ()
   {
      super ();
      init ();
   }
   public CardLayoutDemo (String Title)
   {
      super (Title);
      init ();
   }

   public void init ()
   {
      final int NB_CARDS = 3;

      MyLayout = new CardLayout ();
      CardPanel = new JPanel ();
      CardPanel.setLayout (MyLayout);

      JButton b = new JButton  ("Press here to change card");
      getContentPane ().add (b, BorderLayout.WEST);
      b.addActionListener (this);

      for (int i = 0; i < NB_CARDS; i++)
      {
         JPanel p = new JPanel ();
         p.setLayout (new FlowLayout ());
         p.add (new JLabel ("This is card #" + i));
         CardPanel.add (p, "Card #" + i);
      }

      getContentPane ().add (CardPanel, BorderLayout.EAST);

      addWindowListener
      (
         new WindowAdapter()
         {
            public void windowClosing(WindowEvent e)
            {
               System.exit(0);
            }
         }
      );
   }

   public static void main (String [] args)
   {
      CardLayoutDemo frame = new CardLayoutDemo ("CardLayout demo");
      frame.pack ();
      frame.setVisible (true);
   }

   public void actionPerformed (ActionEvent e)
   {
      MyLayout.next (CardPanel);
   }

}
