import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class GridLayoutDemo extends JFrame
{
   public GridLayoutDemo (String Title)
   {
      super (Title);
      init ();
   }

   public void init ()
   {
      final int NB_ROWS = 3,
                NB_COLUMNS = 2,
                NB_BUTTONS = (NB_ROWS * NB_COLUMNS);

      JButton [] MyButtons = new JButton [NB_BUTTONS];

      final int HORIZONTAL_SPACING =  5,
                VERTICAL_SPACING   = 10;
      getContentPane ().setLayout (new GridLayout (NB_ROWS, NB_COLUMNS,
                                                   HORIZONTAL_SPACING,
                                                   VERTICAL_SPACING));

      for (int i = 0; i < MyButtons.length; i++)
      {
         MyButtons[i] = new JButton ("This is button " + i);
         getContentPane ().add (MyButtons[i]);
      }

      addWindowListener
      (
         new WindowAdapter()
         {
            public void windowClosing(WindowEvent e)
            {
               System.exit(0);
            }
         }
      );
   }

   public static void main (String [] args)
   {
      GridLayoutDemo frame = new GridLayoutDemo ("GridLayout demo");
      frame.pack ();
      frame.setVisible (true);
   }
}
