import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class MenuDemo extends JFrame implements ActionListener
{
   private JMenu menuFile, menuEdit;

   // The label to alter according to the user's selections
   private JLabel demoText;

   public MenuDemo (String Title)
   {
      super (Title);
      init ();
   }

   private JMenuItem CreateMenuItem (String Name, char Mnemonic)
   {
      JMenuItem jmi = new JMenuItem (Name);
      jmi.setMnemonic (Mnemonic);
      jmi.addActionListener (this);
      return jmi;
   }

   public void init ()
   {
      demoText = new JLabel ("For demonstration purpose only");
      demoText.setFont (new Font ("Arial", Font.PLAIN, 14));
      getContentPane ().add (demoText, BorderLayout.CENTER);

      // Create the File menu
      menuFile = new JMenu ("File");
      menuFile.setMnemonic ('F');

      // -- add some items to the menu
      menuFile.add (CreateMenuItem ("Open", 'O'));
      menuFile.add (CreateMenuItem ("Save", 'S'));
      menuFile.addSeparator ();
      menuFile.add (CreateMenuItem ("Quit", 'Q'));

      // Create the Edit menu
      menuEdit = new JMenu ("Edit");
      menuEdit.setMnemonic ('E');

      // -- add some items to the menu
      menuEdit.add (CreateMenuItem ("Whatever", 'W'));

      // The menu bar
      JMenuBar jmb = new JMenuBar ();

      jmb.add (menuFile);
      jmb.add (menuEdit);

      setJMenuBar (jmb);
   }

   public void actionPerformed (ActionEvent e)
   {
      // The getActionCommand() instance method of an ActionEvent
      // instance returns the text on the control on which the
      // action has occurred (here, the text on the menu item)
      if (e.getActionCommand ().equals ("Quit"))
         System.exit (0);
      demoText.setText ("You have selected: " + e.getActionCommand ());
   }

   public static void main (String [] args)
   {
      MenuDemo md = new MenuDemo ("Menu Demo");
      md.addWindowListener (
         new WindowAdapter ()
         {
            public void windowClosing (WindowEvent e)
            {
               System.exit (0);
            }
         }
      );
      md.pack ();
      md.setVisible (true);
   }
}

