import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class RatWindow extends JFrame implements MouseListener, MouseMotionListener
{
   private JLabel theStatus;
   public RatWindow (String Title)
   {
      super(Title);
      init ();
   }
   public void init ()
   {
      theStatus= new JLabel ("Last mouse action?");
      getContentPane ().add (theStatus, BorderLayout.CENTER);
      addMouseListener (this);
      addMouseMotionListener (this);
   }
   public void mousePressed (MouseEvent e)
   {
      theStatus.setText ("Mouse press at " + e.getX ()+ "," + e.getY ());
   }
   public void mouseReleased (MouseEvent e)
   {
      theStatus.setText ("Mouse release at " + e.getX ()+ "," + e.getY ());
   }
   public void mouseClicked (MouseEvent e)
   {
      theStatus.setText ("Mouse click at " + e.getX ()+ "," + e.getY ());
   }
   public void mouseDragged (MouseEvent e)
   {
      theStatus.setText ("Mouse drag at " + e.getX ()+ "," + e.getY ());
   }
   public void mouseMoved (MouseEvent e)
   {
      theStatus.setText ("Mouse move at " + e.getX ()+ "," + e.getY ());
   }
   public void mouseEntered (MouseEvent e)
   {
      theStatus.setText ("Mouse just entered the window");
   }
   public void mouseExited (MouseEvent e)
   {
      theStatus.setText ("Mouse just exited the window");
   }
   public static void main (String [] args)
   {
      RatWindow rw = new RatWindow ("Mouse event demo");
      rw.setSize (100, 100);
      rw.setVisible (true);
   }
}
